[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.97 and 1.118

version 1.97, 2021/12/21 02:32:16 version 1.118, 2021/12/24 00:46:02
Line 35 
Line 35 
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
 VERBOSE=false  VERBOSE=false
   DELETE=false
 DOWNLOAD=true  DOWNLOAD=true
 INSTALL=true  INSTALL=true
 LOCALSRC=  LOCALSRC=
Line 62 
Line 63 
         # we have su(1) and doas(1) is unlikely to be configured.          # we have su(1) and doas(1) is unlikely to be configured.
         set -o monitor # make sure ftp gets its own process group          set -o monitor # make sure ftp gets its own process group
         (          (
           flags=-VM
           "$VERBOSE" && flags=-vm
         if [ -x /usr/bin/su ]; then          if [ -x /usr/bin/su ]; then
                 exec /usr/bin/su -s /bin/ksh "$_user" -c \                  exec /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"                      "/usr/bin/ftp -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"
         else          else
                 exec /usr/bin/doas -u "$_user" \                  exec /usr/bin/doas -u "$_user" \
                     /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"                      /usr/bin/ftp -D 'Get/Verify' $flags -o- "$_src" > "$_dst"
         fi          fi
         ) & _pid=$!          ) & _pid=$!
         set +o monitor          set +o monitor
   
         trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM          trap "kill -TERM '-$_pid' 2>/dev/null; exit 1" EXIT INT QUIT ABRT TERM
   
         SECONDS=0          SECONDS=0
         _last=0          _last=0
Line 149 
Line 152 
 }  }
   
 installed_firmware() {  installed_firmware() {
         set +o noglob          local _pre="$1" _match="$2" _post="$3" _firmware
         for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do          set -A _firmware -- $(
                 [ -e "$fw/+CONTENTS" ] || continue              set +o noglob
               grep -Fxl '@option firmware' \
                   "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
                   2>/dev/null || true
               set -o noglob
           )
   
           [ "${_firmware[*]:-}" ] || return 0
           for fw in "${_firmware[@]}"; do
                   fw="${fw%/+CONTENTS}"
                 echo "${fw##*/}"                  echo "${fw##*/}"
         done          done
         set -o noglob  
 }  }
   
 add_firmware () {  add_firmware () {
         local _f="${1##*/}"          local _f="${1##*/}" _pkgname
         local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"          local _tmpdir="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
         ftp -D "Install" -Vmo- "file:${1}" |          local flags=-VM
                 tar -s ",^\+,${_pkgdir}/+," \          "$VERBOSE" && flags=-vm
           ftp -D "Install" "$flags" -o- "file:${1}" |
                   tar -s ",^\+,${_tmpdir}/+," \
                     -s ",^firmware,${DESTDIR}/etc/firmware," \                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                     -C / -zxphf - "+*" "firmware/*"                      -C / -zxphf - "+*" "firmware/*"
   
           _pkgname="$( sed -n '/^@name /{s///p;q;}' "${_tmpdir}/+CONTENTS" )"
           if [ ! "$_pkgname" ]; then
                   echo "Failed to extract name from $1, partial install" 2>&1
                   rm -rf "$_tmpdir"
                   return 1
           fi
   
         # TODO: Should we mark these so real fw_update can -Drepair?          # TODO: Should we mark these so real fw_update can -Drepair?
         ed -s "${_pkgdir}/+CONTENTS" <<EOL          ed -s "${_tmpdir}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 174 
Line 194 
 .  .
 w  w
 EOL  EOL
   
           chmod 755 "$_tmpdir"
           mv "$_tmpdir" "${DESTDIR}/var/db/pkg/${_pkgname}"
 }  }
   
 delete_firmware() {  delete_firmware() {
         local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
   
         # TODO: Check hash for files before deleting          # TODO: Check hash for files before deleting
         echo "Uninstalling $_pkg"          "$VERBOSE" && echo "Uninstalling $_pkg"
         _cwd="${_pkgdir}/$_pkg"          _cwd="${_pkgdir}/$_pkg"
   
           if [ ! -e "$_cwd/+CONTENTS" ] ||
               ! grep -Fxq '@option firmware' "$_cwd/+CONTENTS"; then
                   echo "${0##*/}: $_pkg does not appear to be firmware" >&2
                   return 2
           fi
   
         set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
   
         while read -r c g; do          while read -r c g; do
Line 212 
Line 241 
 }  }
   
 usage() {  usage() {
         echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"          echo "usage:  ${0##*/} [-d | -D | -L] [-av] [driver | file ...]"
         exit 2          exit 2
 }  }
   
   ALL=false
 OPT_D=  OPT_D=
 OPT_L=  OPT_L=
 while getopts DL name  while getopts :adDLv name
 do  do
        case "$name" in         case "$name" in
          a) ALL=true ;;
          d) DELETE=true ;;
        D) OPT_D=true ;;         D) OPT_D=true ;;
        L) OPT_L=true ;;         L) OPT_L=true ;;
        v) VERBOSE=true ;;         v) VERBOSE=true ;;
        ?) usage 2 ;;         ?) echo "${0##*/}: unknown option -- -$OPTARG"; usage 2 ;;
        esac         esac
 done  done
 shift $((OPTIND - 1))  shift $((OPTIND - 1))
Line 240 
Line 272 
         DOWNLOAD=false          DOWNLOAD=false
         LOCALSRC=.          LOCALSRC=.
 else  else
         LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"          LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
 fi  fi
   
 CFILE="$LOCALSRC/$CFILE"  CFILE="$LOCALSRC/$CFILE"
   
 if "$INSTALL" && [ -x /usr/bin/id ] && [ $(/usr/bin/id -u) != 0 ]; then  if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
         echo "need root privileges" >&2          echo "need root privileges" >&2
         exit 1          exit 1
 fi  fi
   
 set -A devices -- "$@"  set -A devices -- "$@"
   
 if [ ! "${devices[*]:-}" ]; then  if "$DELETE"; then
         echo -n "Detecting firmware ..."          [ "$OPT_D" ] || [ "$OPT_L" ] && usage 22
   
           set -A installed
           if [ "${devices[*]:-}" ]; then
                   "$ALL" && usage 22
   
                   set -A installed -- $(
                       for d in "${devices[@]}"; do
                           f="${d##*/}"  # only care about the name
                           f="${f%.tgz}" # allow specifying the package name
                           [ "$( firmware_devicename "$f" )" = "$f" ] && f="$f-firmware"
   
                           set -A i -- $( installed_firmware '' "$f-" '*' )
   
                           if [ "${i[*]:-}" ]; then
                                   echo "${i[@]}"
                           else
                                   echo "No firmware found for '$d'" >&2
                           fi
                       done
                   )
           elif "$ALL"; then
                   set -A installed -- $( installed_firmware '*' '-firmware-' '*' )
           fi
   
           deleted=''
           if [ "${installed:-}" ]; then
                   for fw in "${installed[@]}"; do
                           delete_firmware "$fw" || continue
                           deleted="$deleted,$( firmware_devicename "$fw" )"
                   done
           fi
   
           deleted="${deleted:+${deleted#,}}"
           echo "${0:##*/}: deleted ${deleted:-none}";
   
           exit
   fi
   
   if [ "${devices[*]:-}" ]; then
           "$ALL" && usage 22
   else
           "$VERBOSE" && echo -n "Detecting firmware ..."
         set -A devices -- $( devices_needing_firmware )          set -A devices -- $( devices_needing_firmware )
         [ "${devices[*]:-}" ] && echo " found." || echo " done."          "$VERBOSE" &&
               { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
 fi  fi
   
 [ "${devices[*]:-}" ] || exit  [ "${devices[*]:-}" ] || exit
   
 if "$DOWNLOAD"; then  if "$DOWNLOAD"; then
           set +o noclobber # we want to get the latest CFILE
         fetch "$CFILE"          fetch "$CFILE"
           set -o noclobber
         ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
             echo "Signature check of SHA256.sig failed" >&2 && exit 1              echo "Signature check of SHA256.sig failed" >&2 && exit 1
 fi  fi
   
   added=''
   updated=''
   kept=''
 for f in "${devices[@]}"; do  for f in "${devices[@]}"; do
         d="$( firmware_devicename "$f" )"          d="$( firmware_devicename "$f" )"
   
Line 278 
Line 358 
                 exit 2                  exit 2
         fi          fi
   
         set -A installed -- $( installed_firmware "$d" )          set -A installed -- $( installed_firmware '' "$d-firmware-" '*' )
   
         if "$INSTALL" && [ "${installed[*]:-}" ]; then          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         if [ "${f##*/}" = "$i.tgz" ]; then                          if [ "${f##*/}" = "$i.tgz" ]; then
                                 echo "$i already installed"                                  "$VERBOSE" && echo "$i already installed"
                                   kept="$kept,$d"
                                 continue 2                                  continue 2
                         fi                          fi
                 done                  done
Line 291 
Line 372 
   
         if [ -e "$f" ]; then          if [ -e "$f" ]; then
                 if "$DOWNLOAD"; then                  if "$DOWNLOAD"; then
                         echo "Verify existing ${f##*/}"                          "$VERBOSE" && echo "Verify existing ${f##*/}"
                         verify "$f" || continue                          verify "$f" || continue
                           "$INSTALL"  || kept="$kept,$d"
                 # else assume it was verified when downloaded                  # else assume it was verified when downloaded
                 fi                  fi
         elif "$DOWNLOAD"; then          elif "$DOWNLOAD"; then
                 fetch  "$f" || continue                  fetch  "$f" || continue
                 verify "$f" || continue                  verify "$f" || continue
                   "$INSTALL"  || added="$added,$d"
         elif "$INSTALL"; then          elif "$INSTALL"; then
                 echo "Cannot install ${f##*/}, not found" >&2                  echo "Cannot install ${f##*/}, not found" >&2
                 continue                  continue
Line 305 
Line 388 
   
         "$INSTALL" || continue          "$INSTALL" || continue
   
           removed=false
         if [ "${installed[*]:-}" ]; then          if [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         delete_firmware "$i"                          delete_firmware "$i"
                           removed=true
                 done                  done
         fi          fi
   
         add_firmware "$f"          add_firmware "$f"
   
           if "$removed"; then
                   updated="$updated,$d"
           else
                   added="$added,$d"
           fi
 done  done
   
   added="${added:#,}"
   updated="${updated:#,}"
   kept="${kept:#,}"
   if "$INSTALL"; then
           echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
   else
           echo  "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
   fi

Legend:
Removed from v.1.97  
changed lines
  Added in v.1.118

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>